#include "MotionPlanners/TreePlanner/RRT/DDRRT/OOPSMPDDRRT.H"

BeginImplementInstanceFactory(DDRRT, RRTFactory);
RegisterFnFactory( setRadius, FACTORY_VAL_ARG( const double, 0) );
EndImplementInstanceFactory(DDRRT);

OOPSMP::DDRRT::DDRRT(void) : OOPSMP::RRT()
{
    printf("Now I am in the constructor of DDRRT\n");

    m_radius = DEFAULT_DDRRT_RADIUS;
    printf("returned from DDRRT\n");
}

// * we keep sampling for a random configuration until the distance between the
// random configuration and the nearest node is below the radius of the dynamic
// domain of the nearest node

// * if we fail to find a path from the nearest node to the random configuration,
// then the radius of the dynamic domain of the nearest node is reduced.

void OOPSMP::DDRRT::iterate( )
{
    bool below_radius = false;
    DDRRTVertexData_t near;

    while( below_radius == false )
    {
	if(OOPSMPuniform_random() < getGoalBias())
	    getCoreRobotData()->getStateSpace()->copyState(m_aux_xRand, getQuery()->getGoalState());
	else
	    getCoreRobotData()->getValidStateSampler()->sample(m_aux_xRand, 3.0);

	m_aux_vReach->setState( m_aux_xRand );
	m_proximityQuery.setNrNeighbors(1);
	m_proximityQuery.setKey(m_aux_vReach);
	m_proximity->knearest(&m_proximityQuery, &m_proximityResults, NULL);
	
	double distance = m_proximityResults.getDistance( 0 );
	
	near = (DDRRTVertexData_t) (m_proximityResults.getKey(0));

//	printf("distance = %f, radius = %f\n",distance,near->getRadius());
	
	if( distance < near->getRadius() )
	    below_radius = true;
    }

    if( extendBranchTowardState( near->getId(), near, m_aux_xRand ) == -1 )
	near->setRadius( m_radius );

}
